-- /* $Id: pgrpm.sql.in,v 1.22 2008/07/23 23:20:58 nanardon Exp $

--
-- Return the tagname
--
CREATE
 or REPLACE
    FUNCTION rpmtag(INT) RETURNS TEXT AS
    '$libdir/pgrpm', 'rpmtagname' LANGUAGE C IMMUTABLE STRICT;

--
-- Return the internal value
--
CREATE
 or REPLACE
    FUNCTION rpmtag(TEXT) RETURNS INT AS
    '$libdir/pgrpm', 'rpmtagvalue' LANGUAGE C IMMUTABLE STRICT;


--
-- Return 1 if arg1 > arg2, 0 if ==, -1 if arg1 < arg2
--
CREATE
 or REPLACE 
    FUNCTION rpmvercmp(TEXT, TEXT) RETURNS integer AS
    '$libdir/pgrpm', 'pgrpmvercmp' LANGUAGE C IMMUTABLE STRICT;

--
-- Return TRUE if a == b
--
CREATE 
 or REPLACE 
     FUNCTION rpmvercmpeq(TEXT, TEXT) RETURNS boolean AS
    '$libdir/pgrpm', 'pgrpmvercmpeq' LANGUAGE C IMMUTABLE STRICT;

--
-- Return TRUE if a != b
--
CREATE 
 or REPLACE
    FUNCTION rpmvercmpne(TEXT, TEXT) RETURNS boolean AS
    '$libdir/pgrpm', 'pgrpmvercmpne' LANGUAGE C IMMUTABLE STRICT;

--
-- Return TRUE is a > b
--
CREATE
 or REPLACE 
    FUNCTION rpmvercmpgt(TEXT, TEXT) RETURNS boolean AS
    '$libdir/pgrpm', 'pgrpmvercmpgt' LANGUAGE C IMMUTABLE STRICT;

--
-- Return TRUE is a >= b
--
CREATE 
 or REPLACE 
    FUNCTION rpmvercmpget(TEXT, TEXT) RETURNS boolean AS
    '$libdir/pgrpm', 'pgrpmvercmpget' LANGUAGE C IMMUTABLE STRICT;

--
-- Return TRUE if a < b
--
CREATE 
 or REPLACE 
    FUNCTION rpmvercmplt(TEXT, TEXT) RETURNS boolean AS
    '$libdir/pgrpm', 'pgrpmvercmplt' LANGUAGE C IMMUTABLE STRICT;

--
-- Return TRUE if a <= b
--
CREATE 
 or REPLACE 
    FUNCTION rpmvercmplet(TEXT, TEXT) RETURNS boolean AS
    '$libdir/pgrpm', 'pgrpmvercmplet' LANGUAGE C IMMUTABLE STRICT;

--
-- Return min value
--
CREATE
 or REPLACE
    FUNCTION rpmvercmpmin(TEXT, TEXT) RETURNS TEXT AS
    '$libdir/pgrpm', 'pgrpmvercmpmin' LANGUAGE C IMMUTABLE STRICT;

 DROP AGGREGATE rpmmin (TEXT);
create AGGREGATE rpmmin ( sfunc = rpmvercmpmin, bASetype = text, stype = text);

--
-- Return max value
--
CREATE
 or REPLACE
    FUNCTION rpmvercmpmax(TEXT, TEXT) RETURNS TEXT AS
    '$libdir/pgrpm', 'pgrpmvercmpmax' LANGUAGE C IMMUTABLE STRICT;

 DROP AGGREGATE rpmmax (TEXT);
create AGGREGATE rpmmax ( sfunc = rpmvercmpmax, bASetype = text, stype = text);

 DROP OPERATOR CLASS evr_ops USING btree CASCADE;
 DROP OPERATOR == (text, text);
 DROP OPERATOR <=> (text, text);
 DROP OPERATOR << (text, text);
 DROP OPERATOR <<= (text, text);
 DROP OPERATOR >> (text, text);
 DROP OPERATOR >>= (text, text);

CREATE OPERATOR == (
    leftarg = text,
    rightarg = text,
    procedure = rpmvercmpeq,
    commutator = ==,
    negator = <=>,
    restrict = eqsel,
    join = eqjoinsel
);

CREATE OPERATOR <=> (
    leftarg = text,
    rightarg = text,
    procedure = rpmvercmpne,
    commutator = <=>,
    negator = ==,
    restrict = neqsel,
    join = neqjoinsel
);

CREATE OPERATOR << (
    leftarg = text,
    rightarg = text,
    procedure = rpmvercmplt,
    commutator = >>,
    negator = >>=,
    restrict = scalarltsel,
    join = scalarltjoinsel
);

CREATE OPERATOR <<= (
    leftarg = text,
    rightarg = text,
    procedure = rpmvercmplet,
    commutator = >>=,
    negator = >>,
    restrict = scalarltsel,
    join = scalarltjoinsel
);


CREATE OPERATOR >> (
    leftarg = text,
    rightarg = text,
    procedure = rpmvercmpgt,
    commutator = <<,
    negator = <<=,
    restrict = scalargtsel,
    join = scalargtjoinsel
);

CREATE OPERATOR >>= (
    leftarg = text,
    rightarg = text,
    procedure = rpmvercmpget,
    commutator = <<=,
    negator = <<,
    restrict = scalargtsel,
    join = scalargtjoinsel
);

CREATE OPERATOR CLASS evr_ops
    FOR TYPE text USING btree AS
        OPERATOR        1       << ,
        OPERATOR        2       <<= ,
        OPERATOR        3       == ,
        OPERATOR        4       >>= ,
        OPERATOR        5       >>,
        FUNCTION        1       rpmvercmp(text, text);

--
-- Return TRUE if match
--
CREATE
 or REPLACE
    FUNCTION rpmdepmatch(INT, TEXT, INT, TEXT) RETURNS boolean AS
    '$libdir/pgrpm', 'rpmdepmatch_evr' LANGUAGE C IMMUTABLE CALLED ON NULL INPUT;

--
-- Return TRUE if match
--
CREATE
 or REPLACE
    FUNCTION rpmdepmatch(TEXT, INT, TEXT, TEXT, INT, TEXT) RETURNS boolean AS
    '$libdir/pgrpm', 'rpmdepmatch_nevr' LANGUAGE C IMMUTABLE CALLED ON NULL INPUT;

--
-- Return a textual reprsentation of sense flags
--
CREATE
 or REPLACE
    FUNCTION rpmsenseflag(TEXT) RETURNS INT AS
    '$libdir/pgrpm', 'rpmSenseTexttoFlag' LANGUAGE C IMMUTABLE STRICT;

--
-- The reverse of previous function
--
CREATE
 or REPLACE
    FUNCTION rpmsenseflag(INT) RETURNS TEXT AS
    '$libdir/pgrpm', 'rpmSenseFlagtoText' LANGUAGE C IMMUTABLE STRICT;

--
-- Return TRUE if match
--
CREATE
 or REPLACE
    FUNCTION rpmfileflag(INT) RETURNS TEXT AS
    '$libdir/pgrpm', 'rpmfflagstoText' LANGUAGE C IMMUTABLE STRICT;

--
-- Return TRUE if match
--
CREATE
 or REPLACE
    FUNCTION rpmfilemode(INT) RETURNS TEXT AS
    '$libdir/pgrpm', 'rpmfmodetoText' LANGUAGE C IMMUTABLE STRICT;

--
-- Insert a header from a string
--
CREATE
 or REPLACE
    FUNCTION rpmheader_in(bytea) RETURNS rpmheader AS
    '$libdir/pgrpm', 'header_bytea_in' LANGUAGE C IMMUTABLE STRICT;

--
-- Insert a header
--
CREATE
 or REPLACE
    FUNCTION rpmheader_in(cstring) RETURNS rpmheader AS
    '$libdir/pgrpm', 'header_in' LANGUAGE C IMMUTABLE STRICT;

--
-- Output a header
--
CREATE
 or REPLACE
    FUNCTION rpmheader_out(rpmheader) RETURNS cstring AS
    '$libdir/pgrpm', 'header_out' LANGUAGE C IMMUTABLE STRICT;

--
-- Return a header from a rpm file
--
CREATE
 or REPLACE
    FUNCTION rpmheaderfromfile(TEXT) RETURNS rpmheader AS
    '$libdir/pgrpm', 'headerfromfile' LANGUAGE C IMMUTABLE STRICT;

CREATE
 or REPLACE
    FUNCTION rpmqueryformat(rpmheader, TEXT) RETURNS TEXT AS
    '$libdir/pgrpm', 'header_queryformat' LANGUAGE C IMMUTABLE STRICT;

CREATE
 or REPLACE
    FUNCTION rpmquery(rpmheader, INT) RETURNS SETOF TEXT AS
    '$libdir/pgrpm', 'header_query' LANGUAGE C IMMUTABLE STRICT;

CREATE
 or REPLACE
    FUNCTION rpmhastag(rpmheader, INT) RETURNS BOOL AS
    '$libdir/pgrpm', 'header_hastag' LANGUAGE C IMMUTABLE STRICT;

CREATE
 or REPLACE
    FUNCTION rpmhastag(rpmheader, TEXT) RETURNS BOOL AS $$
    select rpmhastag($1, rpmtag($2));
    $$ LANGUAGE SQL IMMUTABLE STRICT;

CREATE
 or REPLACE
    FUNCTION rpmhsize(rpmheader) RETURNS INT4 AS
    '$libdir/pgrpm', 'header_size' LANGUAGE C IMMUTABLE STRICT;

CREATE
 or REPLACE
    FUNCTION rpmtagn(rpmheader, INT, INT) RETURNS TEXT AS
    '$libdir/pgrpm', 'header_gettagn' LANGUAGE C IMMUTABLE STRICT;

CREATE
 or REPLACE
    FUNCTION rpmtagn(rpmheader, TEXT, INT) RETURNS TEXT AS $$
    select rpmtagn($1, rpmtag($2), $3);
    $$ LANGUAGE SQL IMMUTABLE STRICT;

CREATE
 or REPLACE
    FUNCTION rpmtag(rpmheader, INT) RETURNS TEXT AS $$
    select rpmtagn($1, $2, 0);
    $$ LANGUAGE SQL IMMUTABLE STRICT;

CREATE
 or REPLACE
    FUNCTION rpmtag(rpmheader, TEXT) RETURNS TEXT AS $$
    select rpmtagn($1, rpmtag($2), 0);
    $$ LANGUAGE SQL IMMUTABLE STRICT;


CREATE
 or REPLACE
    FUNCTION rpmquery(rpmheader, TEXT) RETURNS SETOF TEXT AS $$
        select * from rpmquery($1, rpmtag($2));
    $$ LANGUAGE SQL;

CREATE
 or REPLACE
    FUNCTION rpmbinquery(rpmheader, INT) RETURNS SETOF BYTEA AS
    '$libdir/pgrpm', 'header_query' LANGUAGE C IMMUTABLE STRICT;

CREATE
 or REPLACE
    FUNCTION rpmbinquery(rpmheader, TEXT) RETURNS SETOF BYTEA AS $$
        select * from rpmbinquery($1, rpmtag($2));
    $$ LANGUAGE SQL;

---- IFUPDATE DROP TYPE rpmheader;
CREATE TYPE rpmheader (
    internallength = variable,
    input = rpmheader_in,
    output = rpmheader_out,
    storage = extended
);

---- IFUPDATE DROP TYPE _rpmfiles;
CREATE TYPE _rpmfiles AS (
    count int4,
    filename TEXT,
    dirname TEXT,
    basename TEXT,
    flags int4,
    vflags int4,
    mode int4,
    md5 TEXT,
    link TEXT,
    "user" TEXT,
    "group" TEXT,
    inode int4,
    size int4,
    rdev int4,
    color int4,
    class TEXT,
    mtime int4,
    nlink int4
);

CREATE
 or REPLACE
    FUNCTION rpmqueryfiles(rpmheader) RETURNS SETOF _rpmfiles AS
        '$libdir/pgrpm', 'header_files_query' LANGUAGE C IMMUTABLE STRICT;

---- IFUPDATE DROP TYPE _rpmfiles;
CREATE TYPE _rpmdeps AS (
    count int4,
    tag int4,
    name text,
    flags int4,
    evr text,
    color int4
);

CREATE
 or REPLACE
    FUNCTION rpmquerydeps(rpmheader, TEXT) RETURNS SETOF _rpmdeps AS
        '$libdir/pgrpm', 'header_deps_query' LANGUAGE C IMMUTABLE STRICT;
    
